//+-----------------------------------------------------------------------+
//| Goblin.mq4                                                            |
//| Original 10Point 3.mq4 Copyright  2005, Alejandro Galindo            |
//| http://elCactus.com                                                   |
//|                                                                       |
//| Modified ver. of 10points 3_dynamic_stop to provide multiple options  |
//| for better trend detection using customized Jurik based indicators.   |
//|                                                                       |
//| bluto @ www.forex-tsd.com; 11/22/2006                                 |
//+-----------------------------------------------------------------------+

/*  Tross Goblin1.2-Fibo release with options

  - Added option for Fibonacci Progression
  - Added Dynamic Pips with ATR
  - Added Dynamic TP with ATR
  - Added Dynamic Stops with ATR
  - Added option for trend order reversal during progression
  - Added option for H4 of H1 periods
  
*/

#property copyright "GobFib2-Options2"
#property link      "http://forex-tsd.com"

extern string    Label1 = "--- Dynamic Settings ---";
extern int       ATRPeriod=5;               // ATR period for Dynamic Calculations, higher is more average
extern bool      DynamicPips=true;          // Use ATR for Pips between orders in progress
extern int       StorePips=0;               // above zero will average with ATR value (Pips)
extern bool      DynamicTP=true;            // Use ATR for pips of TakeProfit
extern double    StoreTP = 0;              // above zero will average with ATR value (TakeProfit)
extern bool      DynamicSL=true;            // Use ATR for pips of InitialStop
extern double    StoreSL = 0;              // above zero will average with ATR value (InitialStop)
extern string    Lable2 = "--- Options Settings ---";
extern bool      ReverseOnTrend=false;       // Reverse consequetive orders depending on trend
extern bool      Use4hourTrend=false;       // Use 4h Trend ala Goblin1
extern bool      CloseOnClose=true;         // Close all orders if any SL/TP has been hit, leaves positions open if false
extern string    Label3 = "--- Goblin Settings ---";
extern int       MaxTrades=10;              // Maximum number of orders to open
extern double    Lots = 0.1;                // First order will be for this lot size
extern bool      FiboProgression=false;     // Set True for Fibonacci sequence instead of Martingale for lot increases
extern double    TrailingStop = 0;          // Pips to trail the StopLoss
extern string    Label4 = "--- Protection Settings ---";
extern double    EquityProtectionLevel;     // Min. equity to preserve in the event things go bad; all orders for Symbol/Magic will be closed.
extern double    MaxLossPerOrder;           // Max. loss tolerance per order; once reached, order will be closed. 
extern int       SecureProfit=0;            // If profit made is bigger than SecureProfit we close the orders
extern int       AccountProtection=0;       // If one the account protection will be enabled, 0 is disabled
extern int       OrderstoProtect=0;         // This number subtracted from MaxTrades is the number of open orders to enable the account protection.
                                            // Eg. (MaxTrades=10)-(OrderstoProtect=3)=7 open orders before account protection is enabled.

extern bool      mm=false;                  // if true, lots size will increase based on account size
extern double    risk=1;                    // risk to calculate the lots size (only if mm is enabled)  
extern int       ReverseCondition=0;        // If one the decision to go long/short will be reversed         
extern int       Magic = 123987;            // Magic number for the orders placed
                         
int              OpenOrders=0, cnt=0;
int              slippage=5;
double           sl=0, tp=0;
double           BuyPrice=0, SellPrice=0;
double           lotsi=0, mylotsi=0;
int              mode=0, myOrderType=0;
bool             ContinueOpening=True;
double           LastPrice=0;
int              PreviousOpenOrders=0;
double           Profit=0;
int              LastTicket=0, LastType=0;
double           LastClosePrice=0, LastLots=0;
double           Pivot=0;
double           PipValue=0;
string           text="", text2="";
double           DnTrendVal=0,UpTrendVal=0,TrendVal=0;
string           TrendTxt="analyzing...";
int              trendtype=0;
bool             AllowTrading=true;
int              StartingBalance;
int              ValueATR=10;
int              Pips=10;      // Pips for range between orders, etc
int              InitialStop=10;
int              TakeProfit=10;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
    StartingBalance = AccountBalance();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
//---- 
   if (AllowTrading==false) {return(0);}     
  
//---- DYNAMIC ASSIGNMENT OF PIPS, TP AND SL.
   if(Seconds()==30) {
     ValueATR=iATR(NULL,PERIOD_M5,60,0)*MathPow(10,Digits);         // SL & TP modifier
     
     if (DynamicPips) {
       Pips = iATR(NULL,0,5,0)*MathPow(10,Digits);
       if (StorePips>0) { Pips = (StorePips + Pips) / 2;}           // average Dynamic and user Pips
       if (Pips < 5) Pips=5;                                        // set Pips to minimum of 5
     } else Pips=StorePips;
       
     if (DynamicSL)  {
       InitialStop = iATR(NULL,0,30,0)*MathPow(10,Digits)+ValueATR; // add fast small ATR value
       if (StoreSL>0) { InitialStop = (StoreSL + InitialStop) /2; } // average Dynamic and user StopLoss
     } else InitialStop=StoreSL;
   
     if (DynamicTP)  {
       TakeProfit = iATR(NULL,0,60,0)*MathPow(10,Digits)-ValueATR;  // subtract small fast ATR value
       if (StoreTP>0) { TakeProfit = (StoreTP + TakeProfit) /2; }   // average Dynamic and user TakeProfit
     } else TakeProfit=StoreTP;
   }//once a minute   


//--- Money Management ---
   if (mm) lotsi=NormalizeDouble(AccountBalance()/StartingBalance*Lots*risk,2);
   else lotsi=Lots;
   
// Added optional provision to specify maximum loss per order; primordial risk management at it's finest. 
   if (MathAbs(MaxLossPerOrder) > 0)
    {
     for(cnt=OrdersTotal();cnt>=0;cnt--) 
      {
       RefreshRates();
       OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
       if (OrderSymbol() == Symbol())
        {
         if (OrderType() == OP_BUY && OrderMagicNumber() == Magic && OrderProfit() <=  MathAbs(MaxLossPerOrder) * (-1)) { OrderClose(OrderTicket(),OrderLots(),Bid,slippage,White); }
         if (OrderType() == OP_SELL && OrderMagicNumber() == Magic && OrderProfit() <= MathAbs(MaxLossPerOrder) * (-1)) { OrderClose(OrderTicket(),OrderLots(),Ask,slippage,White); }
        }
      }
    }

// Added Minimum Equity Level to protect to protect from being wiped out in the event things really get wicked...more elegant risk control stuff.
     if(EquityProtectionLevel > 0 && AccountEquity() <= EquityProtectionLevel)
     {
      AllowTrading = false;
      Print("Min. Equity Level Reached - Trading Halted For ",Symbol());
      Alert("Min. Equity Level Reached - Trading Halted For ",Symbol());
      for(cnt=OrdersTotal();cnt>=0;cnt--)
       {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		   {
		    if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue); }
			 if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red); }
			 return(0);
		   }
	    }
     }      
   
   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   }     
   
   double PipValue = MarketInfo(Symbol(),MODE_TICKVALUE);
   if (PipValue==0) { PipValue=5; }

//---- Close Orders ----//
   if (PreviousOpenOrders>OpenOrders && CloseOnClose)  // close orders normally unless CloseOnClose = false
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red); }
			return(0);
		  }
	  }//for
   }//if 

   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }

   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
		 }
	  }
   }

   if (OpenOrders<1) 
   {
     myOrderType=OpenIndicatedOrders();
 	  if (ReverseCondition==1)
	  {
	  	  if (myOrderType==1) { myOrderType=2; }
		  else { if (myOrderType==2) { myOrderType=1; } }
	  }
   }
   

   // if we have opened positions we take care of them
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
	  {	
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if (OrderOpenPrice()-Ask>=(TrailingStop+Pips)*Point) 
				  {						
					 if (OrderStopLoss()>(Ask+Point*TrailingStop))
					 {			
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderClosePrice()-TakeProfit*Point-TrailingStop*Point,800,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if (Bid-OrderOpenPrice()>=(TrailingStop+Pips)*Point) 
				{
					if (OrderStopLoss()<(Bid-Point*TrailingStop)) 
					{					   
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderClosePrice()+TakeProfit*Point+TrailingStop*Point,800,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
   }
   
   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{			
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			}
			if (LastType==OP_SELL) 
			{
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
			}
	  }
   }
	
	Profit=Profit*PipValue;
	text2="Profit: $"+DoubleToStr(Profit,2)+" +/-";
   if (OpenOrders>=(MaxTrades-OrderstoProtect) && AccountProtection==1) 
   {	    
	     if (Profit>=SecureProfit) 
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
	        ContinueOpening=False;
	        return(0);
	     }
   }

      if (!IsTesting()) 
      {
	     if (myOrderType==3) { text="No conditions to open trades"; }
	     else { text="                         "; }
	     Comment("LastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"   Trend Direction: ",TrendTxt,"  Slope == ",TrendVal,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\n",text2,"\nLots=",lotsi,"\n",text);
      }

      if  (OpenOrders == 0 || ReverseOnTrend) OpenIndicatedOrders();
		    
      if (myOrderType==1 && ContinueOpening) 
      {      
	     if ((Bid-LastPrice)>=Pips*Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point; }	
		    if (InitialStop==0) { sl=0; }
		    else { sl=NormalizeDouble(SellPrice+InitialStop*Point + (MaxTrades-OpenOrders)*Pips*Point, Digits);  }		    
		    mylotsi=lotsi;
		    if (OpenOrders!=0) 
		    {		
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
			     if (FiboProgression)  
			       mylotsi=MathRound(MathPow(1.6180339,cnt+1)/MathSqrt(5))*lotsi;      // Fibonacci progression
              else  
                mylotsi=NormalizeDouble(mylotsi*2,2);    // Martingale progression
			   }
		    }
		    if (mylotsi>100) { mylotsi=100; }
		    if (OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"RF1",Magic,0,Red) != -1)
	       {	
	        if (DynamicPips  && ReverseOnTrend == false)  
	        {
	         for(cnt=0;cnt<OrdersTotal();cnt++)      // fix SL of previous orders if DynamicPips
	          {
              OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
              if (OrderType() == OP_SELL) OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Yellow);
	          }//for
	        }//if
	       }//if
	       
		    return(0);
	     }
      }
      
      if (myOrderType==2 && ContinueOpening) 
      {   
	     if ((LastPrice-Ask)>=Pips*Point || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point; }	
		    if (InitialStop==0)  { sl=0; }
		    else { sl=NormalizeDouble(BuyPrice-InitialStop*Point - (MaxTrades-OpenOrders)*Pips*Point, Digits); }		    
		    mylotsi=lotsi;
		    if (OpenOrders!=0) {		
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
			     if (FiboProgression)  
			       mylotsi=MathRound(MathPow(1.6180339,cnt+1)/MathSqrt(5))*lotsi;  // Fibonacci progression
              else  
                mylotsi=NormalizeDouble(mylotsi*2,2);   // Martingale progression       
			   }
		    }
		    if (mylotsi>100) { mylotsi=100; }
		    if (OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"RF1",Magic,0,Blue) != -1)
	       {	
	        if (DynamicPips  && ReverseOnTrend == false)  {
	        for(cnt=0;cnt<OrdersTotal();cnt++)      // fix SL of previous orders if DynamicPips
	         {
             OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
             if (OrderType() == OP_BUY) OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Yellow);
	         }//for
	        }//if
	       }//if
		   
		    return(0);
	     }
      }   

   return(0);
  }
  
//+---------------------------------------- End of mainline order processing logic  ---------------------------------+

int OpenIndicatedOrders() // Phoenix
    {
       myOrderType=3;

     // EnvelopePeriod 2-10
     // Percent .0023 - .0072
     int EnvelopePeriod = 6;
     double Percent = 0.0048;
     double HighEnvelope1 = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,Percent,MODE_UPPER,1);
     double LowEnvelope1  = iEnvelopes(NULL,0,EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,Percent,MODE_LOWER,1);
     double CloseBar1     = iClose(NULL,0,1);

     // SMAPeriod 2-8
     // SMA2Bars 9-18
     int SMAPeriod = 5;
     int SMA2Bars = 14;
     double SMA1=iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,1);
     double SMA2=iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,SMA2Bars);
      
     //OSMASlow 12-36
     //OSMAFast 5-23
     //OSMASignal 2-15
     int OSMASlow = 24;
     int OSMAFast = 14;
     int OSMASignal = 9;
     double OsMABar2=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,2);
     double OsMABar1=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,1);
     if(SMA2-SMA1<0 && CloseBar1 > HighEnvelope1 && OsMABar2 > OsMABar1) myOrderType=1;  // sell
     if(SMA2-SMA1>0 && CloseBar1 < LowEnvelope1 && OsMABar2 < OsMABar1) myOrderType=2;
    return(myOrderType);
   }